----------------------------------------------------------------
-- Normal Bases sequential multiplier for GF(2^4) (NB_seqmult_GF24.adb)
--
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Gf2m; use Gf2m;
with Finite_Fields_Gf2m; use Finite_Fields_Gf2m;

procedure Nb_Seqmult_Gf2_4 is
   A,B,C: Poly_Vector;
   
begin
   loop
      for I in 0 .. 3 loop 
         Put("A(");Put(I);Put(") = "); Get(A(I)); 
      end loop; New_Line;
      for I in 0 .. 3 loop 
         Put("B(");Put(I);Put(") = "); Get(B(I)); 
      end loop; New_Line;
   
      for I in reverse 0 .. 3 loop
         C(I) := H_Function_Gf2_4(A,B);
         A := Nb_Sq(A);
         B := Nb_Sq(B);
      end loop;
            
      -----------------------------------------------------
   
      Put("C = "); for I in 0 .. 3 loop 
         Put(C(I)); 
      end loop; New_Line; New_Line;
   end loop;
end Nb_Seqmult_Gf2_4;