----------------------------------------------------------------
-- Finite Fields GF2m package body (finite_fields_gf2m.adb)
-- 
-- Defines several funtions for finite fields operations
-- of Chapter 8 examples
----------------------------------------------------------------
package body Finite_Fields_Gf2m is   

   function M2xor(X, Y: Bit) return Bit is
      Z: Bit;
   begin
      Z := (X + Y) mod 2;
      return Z;
   end M2xor; 
   
   function M2and(X, Y: Bit) return Bit is
      Z: Bit;
   begin
      Z := (X * Y) mod 2;
      return Z;
   end M2and;
   
end Finite_Fields_Gf2m;

