----------------------------------------------------------------
-- Normal Bases Exponentiation (NB_exp.adb)
--
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Gf2m; use Gf2m;
with Finite_Fields_Gf2m; use Finite_Fields_Gf2m;

procedure Nb_Exp is
   A,B,C,E: Poly_Vector;
   H: H_Array;
   W: W_Array;
   V,R: Integer;
   
begin
   for I in 1 .. M/2 loop
      H(I) := 0;
   end loop;
   for I in 1 .. M/2 loop
      for J in 1 .. M-1 loop
         W(I,J) := 0;
      end loop;
   end loop;

   V := M/2;   
   
   for I in 1 .. V loop Put("h(");Put(I);Put(") = "); Get(H(I)); end loop;
   for I in 1 .. V loop 
      for J in 1 .. H(I) loop
         Put("W(");Put(I);Put(",");Put(J);Put(") = "); Get(W(I,J)); 
      end loop;
   end loop; New_Line;
   
   loop
      for I in 0 .. M-1 loop Put("A(");Put(I);Put(") = "); Get(A(I)); end loop; New_Line;
      Put("E = "); Get(R);
      --   for i in 0 .. m-1 loop Put("E(");Put(i);Put(") = "); Get(e(i)); end loop; New_Line;

      E := Inttovect(R);
  
      C := A;
      for I in 0 .. M-1 loop
         B(I) := 1;
      end loop;
      for I in 0 .. M-1 loop
         if E(I) = 1 then
            B := Nb_Multiplier(B,C,H,W);
         end if;
         C := Nb_Sq(C);
      end loop;
          
      -----------------------------------------------------
   
      Put("B = "); for I in 0 .. M-1 loop 
         Put(B(I)); 
      end loop; New_Line; New_Line;
   end loop;
end Nb_Exp;
