----------------------------------------------------------------
-- Finite Fields GF2m package (finite_fields_gf2m.ads)
-- 
-- Defines several funtions for finite fields operations
-- of Chapter 8 examples
----------------------------------------------------------------
package finite_fields_GF2m is
   subtype Bit is Natural range 0 .. 1;
--   type Bit is ('0','1');
   type bit_vector is array (natural range <>) of bit;
   
   function m2xor(x, y: bit) return bit;
   function m2and(x, y: bit) return bit;
end finite_fields_GF2m;

